library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity UART_FPGA_S3 is
  port (
    mclk : in std_logic;
    btn : in std_logic;
    rxd : in std_logic ;
    txd : out std_logic
  );
end UART_FPGA_S3;

architecture synthesis of UART_FPGA_S3 is

  -- a completer avec les interfaces des composants 
  -- (diviseurClk, UART, echoUnit)
	component diviseurClk is
	port (
    clk, reset : in  std_logic;
    nclk       : out std_logic);
	end component;
	
	component UARTunit is
	port (
	clk, reset : in  std_logic;
    cs, rd, wr : in  std_logic;
    RxD        : in  std_logic;
    TxD        : out std_logic;
    IntR       : out std_logic;        
    IntT       : out std_logic;         
    addr       : in  std_logic_vector(1 downto 0);
    data_in    : in  std_logic_vector(7 downto 0);
    data_out   : out std_logic_vector(7 downto 0));
	end component;
	
	component echoUnit is
    port (
      clk, reset : in  std_logic;
      cs, rd, wr : out  std_logic;
      IntR       : in std_logic;
      IntT       : in std_logic;
      addr       : out  std_logic_vector(1 downto 0);
      data_in    : in  std_logic_vector(7 downto 0);
      data_out   : out std_logic_vector(7 downto 0));
	end component;

  -- a completer avec les signaux internes pour relier les composants
  signal reset, clk : std_logic;
  signal cs, rd, wr : std_logic;
  signal IntR, IntT : std_logic;
  signal addr : std_logic_vector(1 downto 0);
  signal d1, d2 : std_logic_vector(7 downto 0);

begin

	reset <= not btn;
	-- a completer avec la connexion des composants
  div : diviseurClk
  port map(mclk, reset, clk);
  
  echo : echoUnit
  port map(clk, reset,
			  cs, rd, wr,
			  IntR, IntT,
			  addr,
			  d1, d2);
			  
	uart : UARTunit
	port map(clk, reset,
				cs, rd, wr,
				rxd, txd,
				IntR, IntT,
				addr,
				d2, d1);
				

end synthesis;
